#include "D3Drunner.h"
#include <d3d9.h>
#include "WinClass.h"
#include "App.h"
#include "nGon.h"
#include <d3dx9math.h>
#include <mmsystem.h>
#include "Player.h"

#define NUM_OBJS 100
#define RENDERTARGSIZE 1024


void writeCrap(const char * what);
void writeCrap(unsigned long what);

struct fPOINT;

D3Drunner::D3Drunner(WinClass* myWin)
{
	this->StartUp(myWin);
	this->lockedToPlayer = false;
	
	writeCrap("Done initing Direct3D");
}
void D3Drunner::StartUp(WinClass* myWin)
{
	HRESULT hr;

	myd3d = Direct3DCreate9(D3D_SDK_VERSION); // gives us a pointer

	if(myd3d == NULL)
	{
		writeCrap("Error starting Direct3D");
	}

	D3DPRESENT_PARAMETERS myParams; // all the parameters for our window

	//BackBufferWidth
	//BackBufferHeight
	//D3DFMT_R5G6B5
	//D3DFMT_X8R8G8B8
	//BackBufferCount
	//hDeviceWindow

	this->frameCounter=0;
	
	
	
	
	/*UINT BackBufferWidth, BackBufferHeight;
    D3DFORMAT BackBufferFormat;
    UINT BackBufferCount;
    D3DMULTISAMPLE_TYPE MultiSampleType;
    DWORD MultiSampleQuality;
    D3DSWAPEFFECT SwapEffect;
    HWND hDeviceWindow;
    BOOL Windowed;
    BOOL EnableAutoDepthStencil;
    D3DFORMAT AutoDepthStencilFormat;
    DWORD Flags;
    UINT FullScreen_RefreshRateInHz;
    UINT PresentationInterval;*/

	
	//memset(&myParams,sizeof(myParams),1); // clears enough memory for one parameter set
	ZeroMemory(&myParams,sizeof(myParams));
	myParams.Windowed = TRUE; // we are running windowed
	
	myParams.BackBufferWidth = 1280;
	myParams.BackBufferHeight = 1024;

	/*if(FAILED(
		myd3d->CheckDeviceType(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,D3DFMT_X8R8G8B8,D3DFMT_X8R8G8B8,FALSE)   )    )
	{
		writeCrap("Proposed format not good");
	}*/

	myParams.SwapEffect = D3DSWAPEFFECT_FLIP; // discarfi
	myParams.BackBufferFormat = D3DFMT_X8R8G8B8;
	myParams.EnableAutoDepthStencil = TRUE;
	myParams.AutoDepthStencilFormat = D3DFMT_D16;

	hr = myd3d->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, myWin->getHandle(),D3DCREATE_SOFTWARE_VERTEXPROCESSING,&myParams, &myDevice);

	if(FAILED(hr))
	{
		writeCrap("could not create device");		
	}

	//myDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
	myDevice->SetRenderState( D3DRS_LIGHTING, TRUE ); // turn off D3D lighting for now
	myDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_USEW );
	if(FAILED(hr))
	{
		if(hr == D3DERR_NOTAVAILABLE)
		{
			writeCrap("Formats not available");
		}
		else if(hr == D3DERR_INVALIDCALL)
		{
			writeCrap("Bad adapter stuff");
		}
		writeCrap("Error creating device");
	}

	this->Objects = new Renderable*[NUM_OBJS];
	for(int x=0;x<NUM_OBJS;x++)
	{
		this->Objects[x] = NULL;
	}
	this->curObj=0;
	
	hr = myDevice->CreateDepthStencilSurface( RENDERTARGSIZE,RENDERTARGSIZE,D3DFMT_D16, D3DMULTISAMPLE_NONE, 0, TRUE, &myStencil, NULL );

	if(FAILED(hr))
	{
		writeCrap("could not create depth stencil");
	}

	this->viewX = 0.0f;
	this->viewY = 0.0f;
	this->viewZ = -10.0f;

}
D3Drunner::D3Drunner(WinClass* myWin,Player* playa)
{
	this->StartUp(myWin);
	this->lockedToPlayer = true;
	this->LockedPlayer = playa; 	
	writeCrap("Done initing Direct3D");
}
void D3Drunner::addObj(Renderable* what)
{
	//writeCrap("adding object");
	if(this->curObj < NUM_OBJS)
	{
		this->Objects[curObj] = what;
		curObj++;
	}
}
void D3Drunner::setRotate(bool rotate)
{
	this->rotating = rotate;
}

#define SINE22_5 0.3826834323650897717284599840304
#define SINE102_5 0.97629600711993336597088648960561
#define SINERATIO 2.5511844113191762940109799501034


void D3Drunner::Frame(App* myApp,fPOINT lookAt,float radiusToLook)
{
	this->preRender(myApp);
	myDevice->SetRenderState( D3DRS_AMBIENT, 0x00202020 );
	this->SetupLights();
	
	float length = SINERATIO * radiusToLook;

	fPOINT uVector;
	uVector.x = 1 / sqrt(3);
	uVector.y = 1 / sqrt(3);
	uVector.z = 1 / sqrt(3);

	fPOINT camera = multVect(uVector,length);

	if(!this->lockedToPlayer)
	{
		D3DXVECTOR3 vEyePt( camera.x, camera.y ,camera.z  );
		D3DXVECTOR3 vLookatPt( lookAt.x, lookAt.y, lookAt.z );
		D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
		D3DXMATRIXA16 matView;
		D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
		this->myDevice->SetTransform( D3DTS_VIEW, &matView );
	}
	else
	{
		this->myDevice->SetTransform(D3DTS_VIEW,&this->LockedPlayer->getLookPt());
	}
    
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 500.0f );
    this->myDevice->SetTransform( D3DTS_PROJECTION, &matProj );

	this->Render(myApp);
}
fPOINT D3Drunner::multVect(fPOINT what,float scalar)
{
	what.x *= scalar;
	what.y *= scalar;
	what.z *= scalar;
	return what;
}
void D3Drunner::preRender(App* myApp)
{
	this->myDevice->SetDepthStencilSurface(myStencil);
	short howBlue;
	//howBlue = (short)(((float)(myApp->getX()) / 1024.0f) * 255.0f);
	myDevice->Clear(
		0, // size of rectangle array to be cleared out
		NULL, // address of rectangle array to be cleared out
		D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER , // clear the target and the zbuffer
		D3DCOLOR_ARGB( 0x00, 0x00, 0x00, 0x00), // black
		1.0, // clear the ZBUFFER to this distance
		0);
	//myDevice->SetRenderTarget(0,this->myStencil);
	
	
	//fillBuffer(myApp);
	this->myDevice->BeginScene(); // starts drawing our scene


	
}
void D3Drunner::Render(App* myApp)
{
	this->frameCounter++;

	for(int x=0;x<NUM_OBJS;x++)
	{
		if(this->Objects[x] != NULL)
		{
			for(int y=0;y<2;y++) // does two passes
			{
				this->Objects[x]->Render(myDevice,myApp,y);
			}
		}
	}
	this->myDevice->EndScene();

	// takes (source rectangle, destination rectangle,destination window (uses the device's window since it is null),dirtyRegion)
	this->myDevice->Present(NULL,NULL,NULL,NULL);
}
void D3Drunner::Frame(App* myApp)
{	
	

	this->preRender(myApp);

	myDevice->SetRenderState( D3DRS_AMBIENT, 0x00202020 );
	this->SetupMatrices();
	this->SetupLights();
	// RENDER LIKE A BITCH		

	this->Render(myApp);
}
int counter;
VOID D3Drunner::SetupLights()
{
    D3DMATERIAL9 mtrl;
    ZeroMemory( &mtrl, sizeof(D3DMATERIAL9) );
    mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
    mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
    mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
    mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
    myDevice->SetMaterial( &mtrl );

    // Set up a white, directional light, with an oscillating direction.
    // Note that many lights may be active at a time (but each one slows down
    // the rendering of our scene). However, here we are just using one. Also,
    // we need to set the D3DRS_LIGHTING renderstate to enable lighting
    /*D3DXVECTOR3 vecDir;
    D3DLIGHT9 light;
    ZeroMemory( &light, sizeof(D3DLIGHT9) );
    light.Type       = D3DLIGHT_POINT;
    light.Diffuse.r  = 1.0f;
    light.Diffuse.g  = 1.0f;
    light.Diffuse.b  = 1.0f;
	light.Position.x = 0.0f;
	light.Position.y = 0.0f;
	light.Position.z = 0.0f;
    vecDir = D3DXVECTOR3(cosf(timeGetTime()/350.0f),
                         1.0f,
                         sinf(timeGetTime()/350.0f) );
    D3DXVec3Normalize( (D3DXVECTOR3*)&light.Direction, &vecDir );
    light.Range       = 1000.0f;
	light.Falloff = 0.5f;
	light.Attenuation0 = 0.0f;
	light.Attenuation1 = 0.1f;
	light.Attenuation2 = 0.0f;
    myDevice->SetLight( 0, &light );
    myDevice->LightEnable( 0, TRUE );
    myDevice->SetRenderState( D3DRS_LIGHTING, TRUE );*/

    // Finally, turn on some ambient light.
    //myDevice->SetRenderState( D3DRS_AMBIENT, 0x00202020 );
}
VOID D3Drunner::SetupMatrices()
{
	// For our world matrix, we will just rotate the object about the y-axis.
    

    // Set up the rotation matrix to generate 1 full rotation (2*PI radians) 
    // every 1000 ms. To avoid the loss of precision inherent in very high 
    // floating point numbers, the system time is modulated by the rotation 
    // period before conversion to a radian angle.
    
    //device->SetTransform( D3DTS_WORLD, &matWorld );

	
    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
	if(!this->lockedToPlayer)
	{

		float radius = 50.0f;
		D3DXVECTOR3 vEyePt( cosf( (float)this->frameCounter/200.0f)*radius, 3.0f + this->viewY, sinf( (float)this->frameCounter/200.0f)*radius);
		D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
		D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
		D3DXMATRIXA16 matView;
		D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
		this->myDevice->SetTransform( D3DTS_VIEW, &matView );
	}
	else
	{
		this->myDevice->SetTransform(D3DTS_VIEW,&this->LockedPlayer->getLookPt());
	}

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 500.0f );
    this->myDevice->SetTransform( D3DTS_PROJECTION, &matProj );
}
void D3Drunner::LockToPlayer(Player* who)
{
	this->LockedPlayer = who;
}
void D3Drunner::TransView(float x,float y,float z)
{
	this->viewX += x;
	this->viewY += y;
	this->viewZ += z;

}
/*

*/
D3Drunner::~D3Drunner()
{
	

	if(myDevice != NULL)
	{
		myDevice->Release();
	}
	if(myd3d != NULL)
	{
		myd3d->Release();
	}

	if(myStencil != NULL)
	{
		myStencil->Release();
	}

	delete this->LockedPlayer;
	for(int x=0;x<NUM_OBJS;x++)
	{

		if(this->Objects[x] != NULL)
		{
			delete this->Objects[x];
		}
	}

	delete this->Objects;
}