#include <d3d9.h>
#include "classes.h"

#ifdef USING_TUTV
	#ifdef USING_NORMAL
		#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX0)
	#endif
	#ifdef USING_COLOR
		#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX0)
	#endif
#else
#ifdef USING_NORMAL
	#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL)
#endif
#ifdef USING_COLOR
	#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)
#endif
#endif

struct fPOINT;

class D3Drunner
{
private:
	LPDIRECT3D9 myd3d;
	LPDIRECT3DDEVICE9 myDevice;
	
	Renderable** Objects;
	int curObj;
	bool rotating;
	void fillBuffer(App*);
	void SetupMatrices();
	void SetupLights();
	Player* LockedPlayer;
	bool lockedToPlayer;

	float viewX;
	float viewY;
	float viewZ;
	void StartUp(WinClass*);

	void preRender(App*);
	void Render(App*);

	fPOINT multVect(fPOINT,float);

	int frameCounter;

	LPDIRECT3DSURFACE9 myStencil;
public:
	void TransView(float,float,float);
	void addObj(Renderable* what);	
	void setRotate(bool);
	void LockToPlayer(Player* who);

	D3Drunner(WinClass*);
	D3Drunner(WinClass*,Player*);
	~D3Drunner();
	void Frame(App*);
	void Frame(App*,fPOINT lookAt,float radius); // where to look, and the distance from that point we want to see
	LPDIRECT3DDEVICE9 getDevice() {return myDevice;};
};