#include "DIrunner.h"
#include "WinClass.h"
#include <windows.h>
#include <dinput.h>


void writeCrap(const char *what);
void writeCrap(unsigned long what);


DIrunner::DIrunner(WinClass* window)
{
	
	startKeyboard(window);
	// this creates a mouse object for us.
	startMouse(window);
	POINT mypt;
	GetCursorPos(&mypt);
	this->mouseX=mypt.x;
	this->mouseY=mypt.y;
	this->leftDown=false;
	this->rightDown=false;
	
}
void DIrunner::startKeyboard(WinClass* window)
{
	HRESULT hr;
	
	// simply creates the DirectInput8 object.  This function is essentially a data factory, that creates a class for us
	hr = DirectInput8Create(window->getInst(),DIRECTINPUT_VERSION,IID_IDirectInput8,(void**)&DI,NULL);

	if(FAILED(hr))
	{	writeCrap("Error Creating DirectInput");
	}
	
	// creates our device object.  This will eventually represent our keyboard
	hr = DI->CreateDevice(GUID_SysKeyboard, &keyboard, NULL);

	if(FAILED(hr))
	{	writeCrap("Could not create keyboard device");
	}

	hr = keyboard->SetDataFormat(&c_dfDIKeyboard);

	if(FAILED(hr))
	{	writeCrap("Could not set data format");
	}

	hr = keyboard->SetCooperativeLevel(window->getHandle(),DISCL_FOREGROUND | DISCL_EXCLUSIVE);

	if(FAILED(hr))
	{	writeCrap("Could not set cooperative level");
	}

	keyboard->Acquire();
}
void DIrunner::startMouse(WinClass* window)
{
	HRESULT hr;
	hr = this->DI->CreateDevice(GUID_SysMouse, &mouse, NULL);

	if(FAILED(hr))
	{	writeCrap("Could not create mouse");
	}

	// sets the data format to a mouse data format
	hr = mouse->SetDataFormat(&c_dfDIMouse);

	if(FAILED(hr))
	{	writeCrap("Could not set mouse data format");
	}

	// grabs the mouse nearly-exclusively for us
	hr = mouse->SetCooperativeLevel(window->getHandle(),DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);

	if(FAILED(hr))
	{	writeCrap("Could not set mouse cooperative level");
	}

	// I really don't know what this does.  I shall delete it if I can, later
	HANDLE g_hMouseEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	if (g_hMouseEvent == NULL) 
	{    writeCrap("Could not create mouse event");
	}

	// sets the notification of the event above
	hr = mouse->SetEventNotification(g_hMouseEvent);

	if (FAILED(hr)) 
	{    writeCrap("Could not set notification of mouse event");
	}

	

	DIPROPDWORD dipdw;
    dipdw.diph.dwSize       = sizeof(DIPROPDWORD);
    dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER);
    dipdw.diph.dwObj        = 0;
    dipdw.diph.dwHow        = DIPH_DEVICE;
    dipdw.dwData            = SAMPLE_BUFFER_SIZE; // Arbitary buffer size

    hr = mouse->SetProperty( DIPROP_BUFFERSIZE, &dipdw.diph );
        
	

	// acquires the old mouse
	mouse->Acquire();

	this->mouseX =0;
	this->mouseY =0;
	
}
int DIrunner::getMouseX()
{
	return this->mouseX;
}
int DIrunner::getMouseY()
{
	return this->mouseY;
}
void DIrunner::checkMouse()
{
	this->mouseDX=0;
	this->mouseDY=0;


	DIDEVICEOBJECTDATA data;
	HRESULT hr;
	DWORD numElements = 1; // the number of elements to check

	bool leftClicked = false;
	bool rightClicked = false;

	
	

	bool loopDone=false;
	
	
	while(!loopDone) // as long as the we haven't had an error, we should check for more data
	{		
		numElements =1;
		hr = mouse->GetDeviceData( sizeof(DIDEVICEOBJECTDATA),&data,&numElements,0 );
		
		if(hr == DIERR_INPUTLOST)
		{
			mouse->Acquire();
			hr=this->mouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&data,&numElements,0);
		}
		if(FAILED(hr) || numElements != 1)
		{
			loopDone=true;
		}
		
		switch(data.dwOfs)
		{
			case DIMOFS_X:
				curMove(data.dwData,0); // the cursor moved in the x direction, so we should update it								
				break;
			case DIMOFS_Y:
				curMove(0,data.dwData);
				break;
			case DIMOFS_BUTTON0:
				
				leftClicked=true;
				break;
			case DIMOFS_BUTTON1:
				rightClicked=true;
				break;
		}
	}

	if(leftClicked)
	{	leftDown = !leftDown;
	}
	if(rightClicked)
	{	rightDown = !rightDown;
	}
}
void DIrunner::curMove(int x,int y)
{
	this->mouseX += x;
	this->mouseY += y;
	this->mouseDX += x;
	this->mouseDY += y;
}
int DIrunner::getMouseDX()
{
	return this->mouseDX;
}
int DIrunner::getMouseDY()
{
	return this->mouseDY;
}
bool DIrunner::getLeft()
{
	return leftDown;
}
bool DIrunner::getRight()
{
	return rightDown;
}

int DIrunner::checkKeys()
{
	HRESULT hr;
	memcpy(&lastKeybuffer,&keybuffer,sizeof(char)*256);

	hr = keyboard->GetDeviceState(sizeof(keybuffer),&keybuffer);
	if(FAILED(hr))
	{
		keyboard->Acquire();
		hr = keyboard->GetDeviceState(sizeof(keybuffer),&keybuffer);
		if(FAILED(hr))
		{
			//writeCrap("Total failure of keyboard");
			return -1;
		}
		//writeCrap("Partial failure of keyboard");
		return 0;
	}
	return 0;
}
bool DIrunner::getKeyDown(int index)
{
	if(index < 0 || index > 255)
	{
		writeCrap("getKeyDown: index out of bounds");
		return false;
	}
	else
	{
		return (keybuffer[index] != 0);
	}
}
// this function will check to see if a key's status has changed recently
bool DIrunner::getKeyPress(int index)
{
	if(index >= 0 && index< 256) // if index is in bounds
	{

		// if the key wasn't down last time, but it now...
		if((lastKeybuffer[index] != keybuffer[index]) && keybuffer[index] != 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else // if the index is out of bounds...
	{
		return false;
	}
	

}
