#include "Classes.h"
#include <dinput.h>

#define SAMPLE_BUFFER_SIZE  32

class DIrunner
{
private:
	LPDIRECTINPUT9 DI; // holds the over-riding directInput class
	LPDIRECTINPUTDEVICE9 keyboard;
	LPDIRECTINPUTDEVICE9 mouse;
	
	int mouseX;
	int mouseY;
	int mouseDX;
	int mouseDY;
	bool leftDown;
	bool rightDown;

	char keybuffer[256];
	char lastKeybuffer[256];

	//POINT leftClicks[SAMPLE_BUFFER_SIZE];
	//POINT rightClicks[SAMPLE_BUFFER_SIZE];
	
	int curLeftClickRetrieve; // when the client is retreiving clicks, we need to track which one to send them
	int curRightClickRetrieve; // when the client is retrieving clicks to deal with them

	void startKeyboard(WinClass*);
	void startMouse(WinClass*);
	void curMove(int x,int y);
	void leftClickAdd();
	void rightClickAdd();
public:
	DIrunner(WinClass*);	
	
	int checkKeys();
	bool getKeyDown(int index);
	bool getKeyPress(int index);
	void checkMouse();
	int getMouseX();
	int getMouseY();
	int getMouseDX();
	int getMouseDY();
	bool getLeft();
	bool getRight();
};