#include "LightBall.h"
#include "Rendable.h"

int LightBall::lightCounter=0;

LightBall::LightBall(D3Drunner* runner,float size,float x,float y,float z,float lr,float lg,float lb) : Renderable()
{
	ZeroMemory(&this->myLight,sizeof(D3DLIGHT9));

	this->myLight.Position.x = x;
	this->myLight.Position.y = y;
	this->myLight.Position.z = z;
	this->myLight.Range = log(size);
	this->myLight.Type = D3DLIGHT_POINT;


	this->myLight.Diffuse.r = this->myLight.Ambient.r = lr;
	this->myLight.Diffuse.g = this->myLight.Ambient.g = lg;
	this->myLight.Diffuse.b = this->myLight.Ambient.b = lb;
	this->myNum = lightCounter; // WARNING: THIS WILL CAUSE PROBLEMS
	lightCounter++;
	myLight.Falloff = 1.0f;
	myLight.Attenuation0 = 0.0f;
	myLight.Attenuation1 = 1.0f;
	myLight.Attenuation2 = 0.0f;
}
void LightBall::setPos(float x,float y,float z)
{
	this->myLight.Position.x = x;
	this->myLight.Position.y = y;
	this->myLight.Position.z = z;
}
void LightBall::Transform(float x,float y,float z)
{
	this->myLight.Position.x += x;
	this->myLight.Position.y += y;
	this->myLight.Position.z += z;
}
void LightBall::Render(LPDIRECT3DDEVICE9 device,App* app,int pass)
{	
	if(pass == 0) // if we're on the lighting pass
	{
		device->SetLight(this->myNum,&this->myLight);
		device->LightEnable(this->myNum,TRUE);
		device->SetRenderState( D3DRS_LIGHTING, TRUE );
		// Finally, turn on some ambient light.
		device->SetRenderState( D3DRS_AMBIENT, 0x00202020 );
	}

}