#include "PlanetList.h"
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <io.h>
#include <time.h>



//#define GRAVITY 0.0000000000667  THIS IS THE REAL GRAVITY
#define GRAVITY     0.0000000667


#define GEN_GRAVITY 0.00000000667

#define FORCE_MOD 0.1

void writeCrap(const char*);
void writeCrap(float);

float rnd()
{
	return (float)rand() / (float)RAND_MAX;
}

PlanetList::PlanetList(char* filename)
{
	//if (access(filename,0) != 0)
	//{// number of planets, sun mass, minDist, maxDist, maxMass,minMass
		makePlanets( 20,1000,1.0f,20.0f,100,10);
	//}

	fstream io;
	io.open(filename,fstream::in);

	int pCount=0;
	while(!io.eof())
	{
		float mass,x,y,z,dx,dy,dz;
		io>>mass;
		io>>x;
		io>>y;
		io>>z;
		io>>dx;
		io>>dy;
		io>>dz;
		
		
		pCount++;
		
		writeCrap(pCount);
	}
	writeCrap("planet count: ");
	writeCrap(pCount);
	numPlanets = pCount;

	this->planets = new Planet*[numPlanets];

	io.close();

	io.open(filename,fstream::in);
	pCount=0;
	do
	{
		float mass,x,y,z,dx,dy,dz;
		io>>mass;
		io>>x;
		io>>y;
		io>>z;
		io>>dx;
		io>>dy;
		io>>dz;

		planets[pCount] = new Planet(mass,x,y,z,dx,dy,dz,numPlanets);

		pCount++;
		
		
	} while(!io.eof());
	io.close();

	int tempMax=0;
    for(int x=0;x<numPlanets;x++)
    {	if(planets[x]->getMass() > tempMax)
		{ tempMax = planets[x]->getMass();
		}
    }

	
    this->maxSize = tempMax;
}

PlanetList::PlanetList(int numPlanets)
{
	
	this->numPlanets = numPlanets;
	
	planets = new Planet*[numPlanets];
	//									x       y		z			dx		dy		dz
	planets[0] = new Planet(1000000,6,6,0,0.0,0,0,numPlanets);
    planets[1] = new Planet(10000,  6,9,0,-0.015,0,0,numPlanets);

    planets[2] = new Planet(10000,6,15,0,0.0075,0,0.002,numPlanets);
	
    planets[3] = new Planet(10000,6,0,0,0.01,0,0,numPlanets);
    planets[4] = new Planet(10000,6,6,3,0,0.02,0,numPlanets);
    //planets[5] = new Planet(1000000,15,15,0,0,0,0);

	int tempMax=0;
    for(int x=0;x<this->numPlanets;x++)
    {	if(planets[x]->getMass() > tempMax)
		{ tempMax = planets[x]->getMass();
		}
    }
    this->maxSize = tempMax;
}

void PlanetList::makePlanets(int nPlanets,int starMass,float distMin,float distMax,float massMax,float massMin)
{

	fstream io;
	io.open("c:\\system.txt",fstream::out);

	srand(time(NULL));

	float totalStarMass;
	totalStarMass = ((massMax + massMin)/2)*starMass;

	

	io<<totalStarMass<<" ";		// approximates the total star mass
	io<<"0 ";
	io<<"0 ";	// star x,y,z
	io<<"0 ";
	io<<"0 ";
	io<<"0 ";	// star dx,dy,dz
	io<<"0 ";

	for(int i=0;i<nPlanets;i++)
	{
		float mass,x,y,z,dx,dy,dz,sqrtz;
		mass = (rnd() * (massMax - massMin)) + massMin;
		do
		{
			x = (rnd() * distMax * 2) - distMax;
			y = (rnd() * distMax * 2) - distMax;	// create x,y,z between -distMax and distMax
			z = (rnd() * distMax * 2) - distMax;
			sqrtz = sqrt(x*x + y*y + z*z);

		}	while( sqrtz < distMin || sqrtz > distMax );

		dx = rnd();
		dy = rnd();
		dz = (x*dx + y*dy) / z; // dot product.  This creates a speed vector perpindicular to the position vector.

		float speed = sqrt(dx*dx + dy*dy + dz*dz);
		dx /= speed;
		dy /= speed;	// now we have a thingy moving at exactly 1 unit per second.
		dz /= speed;

		float kEnergy = (GEN_GRAVITY * totalStarMass * mass)/sqrtz;
		
		// kE = mass*velocity^2
		// kE/mass = velocity^2
		// sqrt(kE/mass) = velocity

		cout<<"Required kinetic energy of planet "<<i<<": "<<kEnergy<<endl;

		kEnergy /= mass;
		kEnergy = sqrt(kEnergy);

		dx*= kEnergy;
		dy*= kEnergy;
		dz*= kEnergy;


		io<<mass<<" ";
		io<<x<<" ";
		io<<y<<" ";
		io<<z<<" ";
		io<<dx<<" ";
		io<<dy<<" ";
		io<<dz;

		if(i < nPlanets-1)	// we don't want a final space, or else the planet.exe will read it and fuck shit up
		{	io<<" ";
		}

	}

	io.close();

}

void PlanetList::applyForce(int index,float x,float y,float z)
{
	this->planets[index]->setForceApplied(-1,-x,-y,-z);
}
void Planet::Move()
{
	float tempAccelx = this->xforce / this->mass;
    float tempAccely = this->yforce / this->mass;
	float tempAccelz = this->zforce / this->mass;

    this->xVel += tempAccelx;
    this->yVel += tempAccely;
	this->zVel += tempAccelz;
	//this->zVel = 0;

	this->totalx += this->xVel;
	this->totaly += this->yVel;
	this->totalz += this->zVel;

	this->xPos += this->xVel;
	this->yPos += this->yVel;
	this->zPos += this->zVel;
	
	// since we have compelted a calculation cycle, we should set all the force applied memory bits to false, since nothing has applied force to us this round
	for(int x=0;x<this->nPlanets;x++)
	{
		this->forceApplied[x] = false;
	}
	
}

// this function takes the force that this planet inflicts on another, and applies it to this one as well.  Go newton's laws!
void Planet::setForceApplied(int whichSource,float xF,float yF,float zF)
{
	if(xF != 0)
	{
		this->modXforce = -xF;
	}
	if(yF != 0)
	{
		this->modYforce = -yF;
	}
	if(zF != 0)
	{
		this->modZforce = -zF;
	}
}

// clears this planet out every 10 cycles or so.  This is to tell the planet we are starting a new frame, so the total movement should be reset
void Planet::Clear()
{
	this->totalx = 0;
	this->totaly = 0;
	this->totalz = 0;
	
}
void PlanetList::Run()
{	
	for(int x=0;x<numPlanets;x++)
	{
		planets[x]->Clear();
	}
	for(int y=0;y<1/(FORCE_MOD);y++)
    {	
		for(int x=0;x<numPlanets;x++)
		{	planets[x]->Run(this,x);
		}
		for(x=0;x<numPlanets;x++)
		{
			planets[x]->Move();
		}
	}    
}
PlanetList::~PlanetList()
{
	for(int x=0;x<this->numPlanets;x++)
	{
		delete this->planets[x];
	}
	delete this->planets;
}
float Planet::getdX()
{	return this->xVel;
}
float Planet::getdY()
{	return this->yVel;
}
float Planet::getdZ()
{	return this->zVel;
}
float Planet::gettX()
{	return this->totalx;
}
float Planet::gettY()
{	return this->totaly;
}
float Planet::gettZ()
{	return this->totalz;
}
int Planet::getMass()
{
	return this->mass;
}
float Planet::getX()
{	return this->xPos;
}
float Planet::getY()
{	return this->yPos;
}
float Planet::getZ()
{	return this->zPos;
}
void Planet::Run(PlanetList* planetList,int whichPlanet)
{
	//writeCrap("Planet::Run -  - -- - - -- - - - - - - - -- -  - -- - - - - ");
	this->xforce = this->modXforce ;
    this->yforce = this->modYforce ;
	this->zforce = this->modZforce;

#ifdef USE_COMPLETE_CALC
    for(int x=0;x<planetList->getNumPlanets();x++)
#else
	for(int x=0;x<1;x++)
#endif
    {	float fTempx = 0;
		float fTempy = 0;
		float fTempz = 0;
		Planet* tempPlanet = planetList->getPlanet(x);
		if(tempPlanet != this )//  && !this->forceApplied[x])// if we aren't calculating versus ourselves and a planet hasn't already done it for us..
		{
			fTempx = GRAVITY * this->mass * tempPlanet->getMass();
			
			float dx = (this->xPos - tempPlanet->getX());
			float dy = (this->yPos - tempPlanet->getY());
			float dz = (this->zPos - tempPlanet->getZ());

			float d = sqrt(dx*dx + dy*dy + dz * dz);// + dz*dz);
			float yxangle,zxangle;
			float force = this->gm * tempPlanet->getMass();
			
			force = force / (d*d);
			force *= FORCE_MOD;

			if(dx != 0)
			{
				yxangle = atan(dy/dx);				
				zxangle = atan(dz/dx);
				fTempx = cos(yxangle) * force;
				fTempy = sin(yxangle) * force;
				fTempz = sin(zxangle) * force;
			}
			else // if dx = 0
			{	if(dy != 0)
				{	
					yxangle = atan(dz/dy);				
					fTempx = 0;
					fTempy = cos(yxangle) * force;
					fTempz = sin(yxangle) * force;
				}
				else
				{
					fTempy = 0;
					fTempx = 0;
					fTempz = force;
				}
			}
			
			
			
			//writeCrap("z force");
			//writeCrap(fTempz);		
			
			if(dx >= 0)
			{ fTempx = -sqrt(fTempx * fTempx);
			}
			else
			{ fTempx = sqrt(fTempx * fTempx);
			}

			if(dz >= 0)
			{	fTempz = -sqrt(fTempz*fTempz);
			}
			else
			{	fTempz = sqrt(fTempz*fTempz);
			}

			if(dy >= 0)
			{ fTempy = -sqrt(fTempy*fTempy);
			}
			else
			{ fTempy =(sqrt(fTempy*fTempy));
			}
			//writeCrap("x force");
			//writeCrap(fTempx);
			this->xforce += fTempx;
			this->yforce += fTempy;
			this->zforce += fTempz;

			
		}
	}
	
	

}
int PlanetList::getMaxMass()
{
	return this->maxSize;
}
Planet::Planet(int mass, float xPos,float yPos,float zPos,float xVel,float yVel,float zVel,int nPlanets)
{
	this->xPos = xPos;
    this->yPos = yPos;
	this->zPos = zPos;
    this->mass = mass;
    this->xVel = xVel;
    this->yVel = yVel;
	this->zVel = zVel;
	this->modXforce = 0;
	this->modYforce = 0;
	this->modZforce = 0;
    this->gm = this->mass * GRAVITY;

	this->nPlanets = nPlanets;

	this->forceApplied = new bool[nPlanets];
	for(int x=0;x<nPlanets;x++)
	{
		this->forceApplied[x] = false;
	}
}
Planet::~Planet()
{
	delete this->forceApplied;
}
Planet* PlanetList::getPlanet(int index)
{
	return this->planets[index];
}
int PlanetList::getNumPlanets()
{
	return this->numPlanets;
}