#include "nCube.h"
#include "Player.h"
#include "LightBall.h"
#include "D3Drunner.h"
#include "nTrail.h"


void writeCrap(char const * what);

nCube::nCube(D3Drunner* runner,float size,float x,float y,float z) : nGon(16,runner) 
{
	CUSTOMVERTEX mine[8];
	float sizeOver2 = size / 2;

	mine[0].position.x = (0 + x) - sizeOver2;
	mine[0].position.y = (0 + y) - sizeOver2;
	mine[0].position.z = (0 + z) - sizeOver2;
#ifdef USING_NORMAL
	mine[0].normal.x = -1;
	mine[0].normal.y = -1;
	mine[0].normal.z = -1;	
#endif
	//mine[0].rhw = 1.0f;

	mine[1].position.x = (0 + x) - sizeOver2;
	mine[1].position.y = (0 + y) - sizeOver2;
	mine[1].position.z = (size+z) - sizeOver2;
#ifdef USING_NORMAL
	mine[1].normal.x = -1;
	mine[1].normal.y = -1;
	mine[1].normal.z = 1;
#endif
	//mine[1].rhw = 1.0f;

	mine[2].position.x = (size + x) - sizeOver2;
	mine[2].position.y = (0 + y) - sizeOver2;
	mine[2].position.z = (size + z) - sizeOver2;
#ifdef USING_NORMAL
	mine[2].normal.x = 1;
	mine[2].normal.y = -1;
	mine[2].normal.z = 1;
#endif
	//mine[2].rhw = 1.0f;

	mine[3].position.x = (size + x) - sizeOver2;
	mine[3].position.y = (0 + y) - sizeOver2;
	mine[3].position.z = (0 +z) - sizeOver2;
#ifdef USING_NORMAL
	mine[3].normal.x = 1;
	mine[3].normal.y = -1;
	mine[3].normal.z = -1;
#endif
	//mine[3].rhw = 1.0f;

	mine[4].position.x = (0 + x) - sizeOver2;
	mine[4].position.y = (size + y) - sizeOver2;
	mine[4].position.z = (0+z) - sizeOver2;
#ifdef USING_NORMAL
	mine[4].normal.x = -1;
	mine[4].normal.y = 1;
	mine[4].normal.z = -1;
#endif
#ifdef USING_TUTV
	mine[4].tu = 0.0f;
	mine[4].tv = 0.0f;
#endif
	//mine[4].rhw = 1.0f;
	
	mine[5].position.x = (0 + x) - sizeOver2;
	mine[5].position.y = (size + y) - sizeOver2;
	mine[5].position.z = (size+z) - sizeOver2;
#ifdef USING_NORMAL
	mine[5].normal.x = -1;
	mine[5].normal.y = 1;
	mine[5].normal.z = 1;
#endif
#ifdef USING_TUTV
	mine[5].tu = 0.0f;
	mine[5].tv = 1.0f;
#endif

	//mine[5].rhw = 1.0f;

	mine[6].position.x = (size + x) - sizeOver2;
	mine[6].position.y = (size + y) - sizeOver2;
	mine[6].position.z = (size + z) - sizeOver2;
#ifdef USING_NORMAL
	mine[6].normal.x = 1;
	mine[6].normal.y = 1;
	mine[6].normal.z = 1;
#endif
#ifdef USING_TUTV
	mine[6].tu = 1.0f;
	mine[6].tv = 1.0f;
#endif
	//mine[6].rhw = 1.0f;

	mine[7].position.x = (size + x) - sizeOver2;
	mine[7].position.y = (size + y) - sizeOver2;
	mine[7].position.z = (0 + z) - sizeOver2;
#ifdef USING_NORMAL
	mine[7].normal.x = 1;
	mine[7].normal.y = 1;
	mine[7].normal.z = -1;
#endif
#ifdef USING_TUTV
	mine[7].tu = 1.0f;
	mine[7].tv = 0.0f;
#endif
	//mine[7].rhw = 1.0f;

	TRIANGLE tri;
	tri.v[2] = mine[2];
	tri.v[1] = mine[0]; // bottom part one
	tri.v[0] = mine[1];
	this->addTri(&tri);
	tri.v[2] = mine[0];
	tri.v[1] = mine[2]; // bottom part two
	tri.v[0] = mine[3];
	this->addTri(&tri);
	tri.v[2] = mine[6];
	tri.v[1] = mine[3];
	tri.v[0] = mine[2];
	this->addTri(&tri);
	tri.v[2] = mine[3];
	tri.v[1] = mine[6];
	tri.v[0] = mine[7];
	this->addTri(&tri);
	tri.v[2] = mine[6];
	tri.v[1] = mine[1];
	tri.v[0] = mine[5];
	this->addTri(&tri);
	tri.v[2] = mine[1];
	tri.v[1] = mine[6];
	tri.v[0] = mine[2];
	this->addTri(&tri);
	tri.v[2] = mine[4];
	tri.v[1] = mine[3];
	tri.v[0] = mine[7];
	this->addTri(&tri);
	tri.v[2] = mine[3];
	tri.v[1] = mine[4];
	tri.v[0] = mine[0];
	this->addTri(&tri);
	tri.v[2] = mine[4];
	tri.v[1] = mine[1];
	tri.v[0] = mine[0];
	this->addTri(&tri);
	tri.v[2] = mine[1];
	tri.v[1] = mine[4];
	tri.v[0] = mine[5];
	this->addTri(&tri);
	tri.v[2] = mine[5];
	tri.v[1] = mine[7];
	tri.v[0] = mine[6];
	this->addTri(&tri);
	tri.v[2] = mine[7];
	tri.v[1] = mine[5];
	tri.v[0] = mine[4];
	this->addTri(&tri);

}

ShootCube::ShootCube(D3Drunner* runner,float width, Player* whoShoot) : nCube(runner,width,whoShoot->getX(),whoShoot->getY(),whoShoot->getZ())
{
	this->xVel = whoShoot->getLX();
	this->yVel = whoShoot->getLY();
	this->zVel = whoShoot->getLZ();
	this->myGuy = whoShoot;
	this->shot = false;
}
void ShootCube::Render(LPDIRECT3DDEVICE9 device,App* what,int pass)
{	
	if(this->shot)
	{
		device->SetStreamSource(0,this->myVB,0,sizeof(CUSTOMVERTEX));
		device->SetFVF(D3DFVF_CUSTOMVERTEX);
		device->DrawPrimitive(D3DPT_TRIANGLELIST, 0, this->curTri);
		writeCrap("rendering shootCube");
	}
}
void ShootCube::Shoot()
{
	this->Transform(this->midX - this->myGuy->getX(),this->midX - this->myGuy->getX(),this->midX - this->myGuy->getX());
	this->xVel = myGuy->getLX();
	this->yVel = myGuy->getLY();
	this->zVel = myGuy->getLZ();
	this->shot = true;
	writeCrap("shooted");
}

//LightBall::LightBall(D3Drunner* runner,float size,float x,float y,float z,float lr,float lg,float lb) : Renderable()

LitCube::LitCube(D3Drunner* runner,float width,float x,float y,float z,float range,float lr,float lg, float lb) : nCube(runner,width,x,y,z)
{
	this->myLight = new LightBall(runner,range,x,y,z,lr,lg,lb);
	this->myTrail = new nTrail(runner,120,x,y,z,0.1);
	//HRESULT hr = D3DXCreateTextureFromFile(runner->getDevice(),"ground.bmp",&this->tex);
	this->counter=0;
	this->movement.x=0;
	this->movement.y=0;
	this->movement.z=0;
}
LitCube::LitCube(D3Drunner* runner,float width,float x,float y,float z) : nCube(runner,width,x,y,z)
{
	//(D3Drunner* runner,float size,float x,float y,float z,float lr,float lg,float lb)
	this->myLight = new LightBall(runner,width,x,y,z,1.0f,1.0f,1.0f);
}
LitCube::~LitCube()
{
	if(this->myLight != NULL)
	{
		delete myLight;
	}
	if(this->myTrail != NULL)
	{
		delete myTrail;
	}
}

void LitCube::Render(LPDIRECT3DDEVICE9 device,App* myApp,int pass)
{	
	if(pass == 0)
	{	
		this->myLight->Render(device,myApp,pass);
	}
	else		
	{	
		//device->SetTexture(0,this->tex);
		//device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
		//device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		//device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
		//device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
		nGon::Render(device,myApp,pass);
		this->myTrail->Render(device,myApp,pass);
	}
}
void LitCube::Transform(float x,float y,float z)
{
	counter++;
	nGon::Transform(x,y,z);

	movement.x += x;
	movement.y += y;
	movement.z += z;

	if((counter % 3)==0)
	{
		this->myTrail->Transform(movement.x,movement.y,movement.z);
		movement.x =0;
		movement.y =0;
		movement.z = 0;
	}
	
	this->myLight->Transform(x,y,z);	
	
}