#include <windows.h>
#include <d3d9.h>
#include "classes.h"
#include "Rendable.h"

//#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)
//#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_DIFFUSE)

#ifndef NGONLOAD
#define NGONLOAD

struct MyVector
{
	float x,y,z;
};

class nGon: public Renderable
{
protected:
	
	int maxTri;
	int curTri;
	float midX;
	float midY;
	float midZ;
	bool avgValid; // whether or not the current average is still valid
	D3DMATERIAL9 mtrl;

	MyVector cross(MyVector,MyVector);

	void calcAvg();
	LPDIRECT3DVERTEXBUFFER9 myVB;
	CUSTOMVERTEX* whereVertex;


public:
	
	nGon(int vertices,D3Drunner* myd3d);

	void setMaterial(float r,float g, float b, float a);

	void addTri(TRIANGLE* newTri);
	LPDIRECT3DVERTEXBUFFER9 getVB();
	int getNumTri();
	void Render(LPDIRECT3DDEVICE9,App*,int);
	void setVertex(CUSTOMVERTEX* what,int index);
	void Transform(float,float,float);
	void rotateY(float,float,float); // rotates about a given line
	void rotateY(float); // rotates about centre
	void scale(float);
};
#endif