#include "nTrail.h"
#include "D3Drunner.h"
#include "nGon.h"

void writeCrap(const char* what);
void writeCrap(int what);

nTrail::nTrail(D3Drunner* runner,int segments,float x,float y,float z,float width) : nGon( (segments+1)*4,runner)
{
	this->vecHead = new VecPair[segments];
	this->numSeg = segments;
	this->width = width;
	for(int i=0;i<segments;i++)
	{
		
		this->vecHead[i].vecs[0].x = x-this->width;
		this->vecHead[i].vecs[0].y = y-this->width;
		this->vecHead[i].vecs[0].z = z-this->width;
		this->vecHead[i].vecs[1].x = x+this->width;
		this->vecHead[i].vecs[1].y = y+this->width;
		this->vecHead[i].vecs[1].z = z+this->width;
		
	}

	for(i=0;i<segments*4;i++)
	{
		TRIANGLE test;
		test.v[0].position.x = x;
		test.v[0].position.y = y;
		test.v[0].position.z = y;
		if(i<segments*2)
		{
			test.v[0].normal.x = 0;
			test.v[0].normal.y = 1;
			test.v[0].normal.z = 0;
		}
		else
		{
			test.v[0].normal.x = 0;
			test.v[0].normal.y = -1;
			test.v[0].normal.z = 0;
		}
		this->addTri(&test);
	}
	
	this->curPos = 0;
}
nTrail::~nTrail()
{
	delete this->vecHead;
}
void nTrail::Transform(float x,float y,float z)
{

	//writeCrap("moving");
	//writeCrap(curPos);

	int lastPos = curPos;
	curPos++;

	if(curPos >= this->numSeg)
	{
		curPos = 0;
		//writeCrap("reset");
	}

	this->vecHead[curPos].vecs[0].x = this->vecHead[lastPos].vecs[0].x + x;
	this->vecHead[curPos].vecs[0].y = this->vecHead[lastPos].vecs[0].y + y;
	this->vecHead[curPos].vecs[0].z = this->vecHead[lastPos].vecs[0].z + z;

	this->vecHead[curPos].vecs[1].x = this->vecHead[lastPos].vecs[1].x + x;
	this->vecHead[curPos].vecs[1].y = this->vecHead[lastPos].vecs[1].y + y;
	this->vecHead[curPos].vecs[1].z = this->vecHead[lastPos].vecs[1].z + z;

	this->moveVertices(curPos,lastPos);

	

}
D3DXVECTOR3 convV(MyVector* what)
{
	D3DXVECTOR3 answer;
	answer.x = what->x;
	answer.y = what->y;
	answer.z = what->z;
	return answer;

}
void nTrail::moveVertices(int which,int lastPos)
{
	this->whereVertex[(which*12)+0].position = convV(&this->vecHead[lastPos].vecs[0]);	
	this->whereVertex[(which*12)+2].position = convV(&this->vecHead[curPos].vecs[0]);
	this->whereVertex[(which*12)+1].position = convV(&this->vecHead[curPos].vecs[1]);

	this->whereVertex[(which*12)+3].position = convV(&this->vecHead[lastPos].vecs[0]);
	this->whereVertex[(which*12)+4].position = convV(&this->vecHead[lastPos].vecs[1]);
	this->whereVertex[(which*12)+5].position = convV(&this->vecHead[curPos].vecs[1]);

	
	this->whereVertex[(which*12)+6].position = convV(&this->vecHead[lastPos].vecs[0]);	
	this->whereVertex[(which*12)+7].position = convV(&this->vecHead[curPos].vecs[0]);
	this->whereVertex[(which*12)+8].position = convV(&this->vecHead[curPos].vecs[1]);

	this->whereVertex[(which*12)+9].position = convV(&this->vecHead[lastPos].vecs[0]);
	this->whereVertex[(which*12)+11].position = convV(&this->vecHead[lastPos].vecs[1]);
	this->whereVertex[(which*12)+10].position = convV(&this->vecHead[curPos].vecs[1]);
	/*

	2---1/5   these 2 are vecHead[curPos].vecs[0] and vecHead[curPos].vecs[1]
	|   / |
	|  /  |
	| /   |
	0/3---4   these 2 are vecHead[lastPos].vecs[0] and vecHead[lastPos].vecs[1]
	|     |
	|     |
	.     .
	.     .   rest of trail
	.     .


  */
}